'From Squeak3.0 of 4 February 2001 [latest update: #3414] on 5 February 2001 at 4:41:50 pm'!
"Change Set:		dropHandler
Date:			5 February 2001
Author:			Michael Rueger

Extends the handling of external drop event to also look for file extensions.
Let's you register handlers for types or extension without the need to modify PasteUpMorph.
Example: drop a project file into Squeak. Look in class PasteUpMorph>>registerExternalDropHandler: handler type: typeOrNil extension: extensionOrNil for the example of how project files are registered.
"!

BorderedMorph subclass: #PasteUpMorph
	instanceVariableNames: 'presenter model cursor padding backgroundMorph turtleTrailsForm turtlePen lastTurtlePositions isPartsBin autoLineLayout indicateCursor resizeToFit wantsMouseOverHalos worldState griddingOn '
	classVariableNames: 'DisableDeferredUpdates ExternalDropHandlers MinCycleLapse StillAlive '
	poolDictionaries: ''
	category: 'Morphic-Worlds'!

!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'mir 2/5/2001 16:34'!
dropFiles: anEvent
	"Handle a number of dropped files from the OS.
	TODO:
		- use a more general mechanism for figuring out what to do with the file (perhaps even offering a choice from a menu)
		- remember the resource location or (when in browser) even the actual file handle
	"
	| numFiles stream types handler |
	numFiles _ anEvent contents.
	1 to: numFiles do:[:i|
		stream _ FileStream requestDropStream: i.
		types _ stream mimeTypes.
		handler _ self class lookupExternalDropHandler: stream types: types name: stream name asLowercase.
	handler value: stream value: self value: anEvent].! !


!PasteUpMorph class methodsFor: 'dropping' stamp: 'mir 2/5/2001 16:11'!
externalDropHandlers
	ExternalDropHandlers ifNil: [ExternalDropHandlers _ OrderedCollection new].
	^ExternalDropHandlers! !

!PasteUpMorph class methodsFor: 'dropping' stamp: 'mir 2/5/2001 16:36'!
lookupExternalDropHandler: stream types: types name: streamName

	types ifNotNil: [
		self externalDropHandlers do: [:handler | 
			types do: [:type | (type beginsWith: (handler at: 2) )
				ifTrue: [^handler at: 1]]]].

	self externalDropHandlers do: [:handler | 
		(handler at: 3) ifNotNil: [
			(streamName asLowercase endsWith: (handler at: 3) )
				ifTrue: [^handler at: 1]]].

	^[:dropStream :pasteUp :event | dropStream edit]! !

!PasteUpMorph class methodsFor: 'dropping' stamp: 'mir 2/5/2001 16:33'!
registerExternalDropHandler: handler type: typeOrNil extension: extensionOrNil
	"PasteUpMorph
		registerExternalDropHandler: [:stream :pasteUp :event |
				ProjectLoading
					openFromFile: stream
					fromDirectory: nil
					withProjectView: nil]
		type: nil
		extension: '.pr' "
	self externalDropHandlers add: {handler. typeOrNil. extensionOrNil }! !

!PasteUpMorph class methodsFor: 'dropping' stamp: 'mir 2/5/2001 16:33'!
registerStandardExternalDropHandlers
	"PasteUpMorph registerStandardExternalDropHandlers"

	self externalDropHandlers add: {
		[:stream :pasteUp :event |
			pasteUp addMorph: (SketchMorph withForm: (Form fromBinaryStream: stream binary)) centeredNear: event position].
		 'image/'.
		 nil }! !

!PasteUpMorph class methodsFor: 'dropping' stamp: 'mir 2/5/2001 16:35'!
resetExternalDropHandlers
	"PasteUpMorph resetExternalDropHandlers"
	ExternalDropHandlers _ nil! !

PasteUpMorph class removeSelector: #lookupExternalDropHandler:types:extension:!
"Postscript:
"
PasteUpMorph registerStandardExternalDropHandlers.
PasteUpMorph
		registerExternalDropHandler: [:stream :pasteUp :event |
				ProjectLoading
					openFromFile: stream
					fromDirectory: nil
					withProjectView: nil]
		type: nil
		extension: '.pr' .
!

